package com.fr.plugin.nnsz.sms.client;

/**
 * @Author fr.open
 * @Date 2021/7/23
 * @Description
 **/

import com.fr.log.FineLoggerFactory;
import com.fr.third.org.apache.commons.codec.binary.Base64;

import java.io.*;
import java.net.URL;
import java.net.URLConnection;

public class SMSClient {

    private String apId = "xxx";
    private String secretKey = "xxxx";
    private String ecName = "xxxx";//集团名称
    private String sign = "xxxx";//网关签名编码
    private String addSerial = "";//拓展码 填空
    public String msg = "这是发送短信的内容！";
    public String url = "http://xxxx/sms/norsubmit";//请求url

    public SMSClient() {
    }

    public SMSClient(String apId, String secretKey, String ecName, String sign, String addSerial, String url) {
        this.apId = apId;
        this.secretKey = secretKey;
        this.ecName = ecName;
        this.sign = sign;
        this.addSerial = addSerial;
        this.url =url;
    }

    public String sendMsg(String mobiles, String content) {
        SendReq sendReq = new SendReq();
        sendReq.setApId(apId);
        sendReq.setEcName(ecName);
        sendReq.setSecretKey(secretKey);
        sendReq.setContent(content);
        sendReq.setMobiles(mobiles);
        sendReq.setAddSerial(addSerial);
        sendReq.setSign(sign);

        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append(sendReq.getEcName());
        stringBuffer.append(sendReq.getApId());
        stringBuffer.append(sendReq.getSecretKey());
        stringBuffer.append(sendReq.getMobiles());
        stringBuffer.append(sendReq.getContent());
        stringBuffer.append(sendReq.getSign());
        stringBuffer.append(sendReq.getAddSerial());

        //FineLoggerFactory.getLogger().info(stringBuffer.toString());
        sendReq.setMac(Md5Util.MD5(stringBuffer.toString()).toLowerCase());
        //FineLoggerFactory.getLogger().info(sendReq.getMac());

        String reqText = JSONUtils.obj2json(sendReq);
        String encode = null;
        try {
            encode = Base64.encodeBase64String(reqText.getBytes("UTF-8"));
        } catch (UnsupportedEncodingException e) {
            FineLoggerFactory.getLogger().error(e.getMessage(),e);
        }
        //FineLoggerFactory.getLogger().info(encode);

        String resStr = sendPost(url, encode);

        FineLoggerFactory.getLogger().info("send mess res is {}",resStr);

        SendRes sendRes = JSONUtils.json2pojo(resStr, SendRes.class);

        if (sendRes.isSuccess() && !"".equals(sendRes.getMsgGroup()) && "success".equals(sendRes.getRspcod())) {
        } else {
        }
        return resStr;
    }

    /**
     * main方法测试发送短信，返回1表示成功，0表示失败
     */
    /*public static void main(String[] args){
        int result = sendMsg("xxxxxx",msg);
        System.out.println(result);
    }*/

    /**
     * 向指定 URL 发送POST方法的请求
     *
     * @param url   发送请求的 URL
     * @param param 请求参数
     * @return 所代表远程资源的响应结果
     */
    private static String sendPost(String url, String param) {
        OutputStreamWriter out = null;

        BufferedReader in = null;
        String result = "";
        try {
            URL realUrl = new URL(url);
            URLConnection conn = realUrl.openConnection();
            conn.setRequestProperty("accept", "*/*");
            conn.setRequestProperty("contentType", "utf-8");
            conn.setRequestProperty("connection", "Keep-Alive");
            conn.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
            conn.setDoOutput(true);
            conn.setDoInput(true);

            out = new OutputStreamWriter(conn.getOutputStream());
            out.write(param);
            out.flush();


            in = new BufferedReader(
                    new InputStreamReader(conn.getInputStream()));
            String line;
            while ((line = in.readLine()) != null) {
                result += "\n" + line;
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (out != null) {
                    out.close();
                }
                if (in != null) {
                    in.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return result;
    }

}